(* declare_raise_exc.ml: declare exception types *)

(* declaration is similar to syntax for algebraic types *)
exception Screwup;;

exception Meltdown of int;;

exception Kersplosion of { radius : float;
                           damage : int;   };;

(* keyword raise will raise an exception *)
raise Screwup;;

raise (Meltdown 5);;

raise (Meltdown 2);;

raise (Kersplosion{radius=5.46; damage=20});;

let e = Meltdown 2 in           (* create, don't raise *)
raise e;;                       (* now raise *)

